# 5.1 함수 
date()
x <- 2.71828182845       # x에 2.71828182845를 대입 
log(x)                   # x를 인수로 넣고 log(x)를 계산한다 
x <- 10                  # x에 10을 대입 
log(x^2, base=10)        # 밑을 지수로 하는 인수 base에 10을 지정해서 로그를 계산 



# 5.2 함수 정의의 기본 
myfunc01 <- function() {      # 
  return(1)                   # 함수정의부분 
  }                           #
myfunc01()                    # 함수를 실행한다 

myfunc02 <- function(x) {     # 
  return(x)                   # 함수정의부분 
}                             #
myfunc02(2)                   # 함수를 실행한다 

myfunc01 <- function() {
  return(1)
}

mydouble <- function(x) {     # 
  return(2*x)                 # 함수정의부분 
}                             #
mydouble(5)                   # 함수를 실행한다 

mytimes <- function(x, y) {   # 
  return(x*y)                 # 함수정의부분 
}                             #
mytimes(3,4)                  # 함수를 실행한다 


# 5.3 프로그램의 기본 
myabs <- function(x) {
  if (x < 0) {
    return(-x)
  }
  else {
    return(x)
  }
}
myabs(-2)
myabs(3)

myloop <- function() {
  a <- 0
  for (i in 1:5) {
    a <- a+1
  }
  return(a)
}
myloop()

myloop2 <- function() {
  a <- 0
  for (i in 3:7) {
    a <- a+1
  }
  return(a)
}
myloop2()

mysum <- function(n) {
  i <- 0
  for (j in 1:n) {
    i <- i + j
  }
  return(i)
}
mysum(5)



# 5.4 팁 
myfunc <- function(x) return(2*x)   # 한 줄짜리 함수정의의 예 
myabs  <- function(x) {
  if (x < 0) return(-x)             # 한 줄짜리 조건분기의 예
  else       return(x)              # 한 줄짜리 조건분기의 예
}

myfunc <- function(x) {
  2*x                               # return(2*x)과 같다 
}
myfunc(5)

x <- 1
if ((-2 < x) && (x < 2))            # (x가-2보다 크다) 그리고 (x가 2미만)
if ((x >= 2) || (x <= -2))          # (x가 2 이상) 또는 (x가 -2 이하) 

x <- c(1, 2, 3)
((x >= c(1, 1, 1)) | (x < c(3,3,3)))
((x >= c(1, 1, 1)) & (x < c(3,3,3)))

myfunc <- function(x) {
  if (x < 0)                    return(-x)
  else if ((0 <= x) && (x < 5)) return(5)
  else                          return(x)
}

x <- 1:4                            # 대입만해선 결과가 표시되지 않는다 
(x <- 1:4)                          # 괄호로 에워싸면 대입한 결과를 표시한다 
myfunc1 <- function(x) y <- 2*x
myfunc1(1:4)                        # 아무것도 표시되지 않는다 
myfunc2 <- function(x) (y <- 2*x)
myfunc2(1:4)                        # 괄호로 에워싸면 대입하고 표시된다

